/* OGIresLPC
 *
 * This module of the Festival TTS system is not part of the original
 * CSTR/University of Edinburgh release.  In addition to conditions
 * disclaimers below, please see the file "license.ogi" in the CSLU
 * Toolkit distribution for information on usage and redistribution,
 * and for a DISCLAIMER OF ALL WARRANTIES.
 *  
 * Festival is being redistributed with permission of CSTR as part of
 * the CSLU Toolkit.
 *
 * The CSLU Toolkit is 
 *    Copyright (C)1997 Center for Spoken Language Understanding,
 *                      Oregon Graduate Institute of Science & Technology
 * 
 */

/*************************************************************************/
/*                                                                       */
/*                Centre for Speech Technology Research                  */
/*                     University of Edinburgh, UK                       */
/*                       Copyright (c) 1996,1997                         */
/*                        All Rights Reserved.                           */
/*                                                                       */
/*  Permission to use, copy, modify, distribute this software and its    */
/*  documentation for research, educational and individual use only, is  */
/*  hereby granted without fee, subject to the following conditions:     */
/*   1. The code must retain the above copyright notice, this list of    */
/*      conditions and the following disclaimer.                         */
/*   2. Any modifications must be clearly marked as such.                */
/*   3. Original authors' names are not deleted.                         */
/*  This software may not be used for commercial purposes without        */
/*  specific prior written permission from the authors.                  */
/*                                                                       */
/*  THE UNIVERSITY OF EDINBURGH AND THE CONTRIBUTORS TO THIS WORK        */
/*  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      */
/*  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   */
/*  SHALL THE UNIVERSITY OF EDINBURGH NOR THE CONTRIBUTORS BE LIABLE     */
/*  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    */
/*  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   */
/*  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          */
/*  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       */
/*  THIS SOFTWARE.                                                       */
/*                                                                       */
/*************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <string.h>

char *db_alloc_print(int size, int lineno, char *file){
  static int Firsttime=1;
  char *p=NULL;
  FILE *fp;
   
  if (Firsttime){
    fp = fopen("malloc.dat","w");
    Firsttime = 0;
  }
  else
    fp = fopen("malloc.dat","a");

  fprintf(fp,"%p\t%d\t%s\t%d ",(p),lineno,file,size); 
  
  p = (char *) malloc(size);

  if (p == NULL)
    {
      fprintf(stderr,"WALLOC: failed to malloc %d bytes\n",size);
      exit(-1);  
    }
  fprintf(fp," ok\n");

  fclose(fp); 
  return p;
}
char *db_calloc_print(int Nelem, int sizeelem, int lineno, char *file){
  char *p;
  FILE *fp;
  
  p = (char *) calloc(Nelem, sizeelem);

  if (p == NULL)
    {
      fprintf(stderr,"WALLOC: failed to malloc %d bytes\n",Nelem*sizeelem);
      exit(-1); 
    }
  
  fp = fopen("malloc.dat","a");

  fprintf(fp,"%p\t%d\t%s\t%d\n",(p),lineno,file,sizeelem*Nelem); 
  fclose(fp);
  
  return p;
}

char *db_realloc_print(char *p, int size, int lineno, char *file){
  FILE *fp;
  char *oldp;

  oldp = p;

  p = (char *) realloc(p,size);

  if (p == NULL)
    {
      fprintf(stderr,"WALLOC: failed to realloc %d bytes\n",size);
      exit(-1);  /* I'd rather not do this but this is the only safe */
      /* thing to do */
    }
  
  if (oldp != p){
    fp = fopen("free.dat","a");
    fprintf(fp,"%p\t%d\t%s\n",oldp,lineno,file); 
    fclose(fp);
   
    fp = fopen("malloc.dat","a");
    fprintf(fp,"%p\t%d\t%s\t%d\n",p,lineno,file,size); 
    fclose(fp);
  }
  return p;
}


void db_free_print(int lineno, char *file, char *p){
  static int Firsttime=1;
  FILE *fp;

  if (Firsttime){
    fp = fopen("free.dat","w");
    Firsttime = 0;
  }
  else
    fp = fopen("free.dat","a");

  fprintf(fp,"%p\t%d\t%s\n",(p),lineno,file); 
  fclose(fp);
   
  if (p != NULL)
    free(p);
}
