/* OGIresLPC
 *
 * This module of the Festival TTS system is not part of the original
 * CSTR/University of Edinburgh release.  In addition to conditions
 * disclaimers below, please see the file "license.ogi" in the CSLU
 * Toolkit distribution for information on usage and redistribution,
 * and for a DISCLAIMER OF ALL WARRANTIES.
 *  
 * Festival is being redistributed with permission of CSTR as part of
 * the CSLU Toolkit.
 *
 * The CSLU Toolkit is 
 *    Copyright (C)1997 Center for Spoken Language Understanding,
 *                      Oregon Graduate Institute of Science & Technology
 * 
 */

/*************************************************************************/
/*                                                                       */
/*                Centre for Speech Technology Research                  */
/*                     University of Edinburgh, UK                       */
/*                       Copyright (c) 1996,1997                         */
/*                        All Rights Reserved.                           */
/*                                                                       */
/*  Permission to use, copy, modify, distribute this software and its    */
/*  documentation for research, educational and individual use only, is  */
/*  hereby granted without fee, subject to the following conditions:     */
/*   1. The code must retain the above copyright notice, this list of    */
/*      conditions and the following disclaimer.                         */
/*   2. Any modifications must be clearly marked as such.                */
/*   3. Original authors' names are not deleted.                         */
/*  This software may not be used for commercial purposes without        */
/*  specific prior written permission from the authors.                  */
/*                                                                       */
/*  THE UNIVERSITY OF EDINBURGH AND THE CONTRIBUTORS TO THIS WORK        */
/*  DISCLAIM ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING      */
/*  ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT   */
/*  SHALL THE UNIVERSITY OF EDINBURGH NOR THE CONTRIBUTORS BE LIABLE     */
/*  FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES    */
/*  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN   */
/*  AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,          */
/*  ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF       */
/*  THIS SOFTWARE.                                                       */
/*                                                                       */
/*************************************************************************/
#ifndef __DB_ALLOC_H__
#define __DB_ALLOC_H__

#include "EST_walloc.h"

#define DEBUG_ALLOC 0

#if DEBUG_ALLOC

#define dballoc(TYPE,SIZE) ((TYPE *) db_alloc_print(sizeof(TYPE)*(SIZE),__LINE__,__FILE__))
#define dbcalloc(TYPE,SIZE) ((TYPE *) db_calloc_print((SIZE), sizeof(TYPE),__LINE__,__FILE__))
#define dbrealloc(P,SIZE) (db_realloc_print((char *)(P),(SIZE),__LINE__,__FILE__))
#define dbfree(P) db_free_print(__LINE__,__FILE__,(char *)(P))

char *db_alloc_print(int sz, int lineno, char *file);
char *db_calloc_print(int Nelem, int szelem, int lineno, char *file);
char *db_realloc_print(char *p, int sz, int lineno, char *file);
void db_free_print(int lineno, char *file, char *p);

#else

#define dballoc(TYPE,SIZE) walloc(TYPE,(SIZE))
#define dbcalloc(TYPE,SIZE) wcalloc(TYPE,(SIZE))
#define dbrealloc(P,SIZE) realloc((P),(SIZE))
#define dbfree(P) wfree(P)

#endif

#ifndef group_fread
#define group_fread(A,B,C,D) if (fread(A,B,C,D) != (unsigned int) (C)) {fprintf(stderr,"OGIresLPC:%s:line %d:  group file read failed\n",__FILE__,__LINE__); festival_error();}
#endif

#define OGI_check_realloc(A,B) {if ((A) == NULL){ cout << "\n resLPC: failed to realloc " << (B) << " bytes \n"; exit(-1);}}


#endif
