/*-
 * Copyright (c) 1993, 1994, 1995, 1996 Michael B. Durian.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Michael B. Durian.
 * 4. The name of the the Author may be used to endorse or promote 
 *    products derived from this software without specific prior written 
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
#include <tcl.h>
#include "MIDI/AllEvent.h"

extern void Tclm_ParseEvent(Event *e);
extern void Tclm_ParseNoteOff(NoteOffEvent *e);
extern void Tclm_ParseNoteOn(NoteOnEvent *e);
extern void Tclm_ParseNote(NoteOnEvent *e);
extern void Tclm_ParseKeyPressure(KeyPressureEvent *e);
extern void Tclm_ParseParameter(ParameterEvent *e);
extern void Tclm_ParseProgram(ProgramEvent *e);
extern void Tclm_ParseChannelPressure(ChannelPressureEvent *e);
extern void Tclm_ParsePitchWheel(PitchWheelEvent *e);
extern void Tclm_ParseSystemExclusive(SystemExclusiveEvent *e);
extern void Tclm_ParseMetaSequenceNumber(MetaSequenceNumberEvent *e);
extern void Tclm_ParseMetaText(MetaTextEvent *e);
extern void Tclm_ParseMetaCopyright(MetaCopyrightEvent *e);
extern void Tclm_ParseMetaSequenceName(MetaSequenceNameEvent *e);
extern void Tclm_ParseMetaInstrumentName(MetaInstrumentNameEvent *e);
extern void Tclm_ParseMetaLyric(MetaLyricEvent *e);
extern void Tclm_ParseMetaMarker(MetaMarkerEvent *e);
extern void Tclm_ParseMetaCue(MetaCueEvent *e);
extern void Tclm_ParseMetaChannelPrefix(MetaChannelPrefixEvent *e);
extern void Tclm_ParseMetaPortNumber(MetaPortNumberEvent *e);
extern void Tclm_ParseMetaEndOfTrack(MetaEndOfTrackEvent *e);
extern void Tclm_ParseMetaTempo(MetaTempoEvent *e);
extern void Tclm_ParseMetaSMPTE(MetaSMPTEEvent *e);
extern void Tclm_ParseMetaTime(MetaTimeEvent *e);
extern void Tclm_ParseMetaKey(MetaKeyEvent *e);
extern void Tclm_ParseMetaSequencerSpecific(MetaSequencerSpecificEvent *e);
extern void Tclm_ParseMetaUnknown(MetaUnknownEvent *e);


// from tclmidi.h  MWM

extern void Tclm_ParseData(const unsigned char *data, long length);
