#include "festival.h"
#include "MIDI/Song.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "fl_midi_parse.h"
#include "fl_midi_print.h"

void read_midifile(const char *fname){

  int fd;
  short track;
  Event *event;
  Song mf;
  
  if ((fd = open (fname, O_RDONLY, 0)) == -1){
    cout << "couldn't open file \n";
    festival_error();
  }
  
  mf.SMFRead(fd);
  
  
  
  cout << "*** opened MIDI fd = " << fd << endl;
  cout << "\tformat  = " << mf.GetFormat() << endl;
  cout << "\t#tracks = " << mf.GetNumTracks() << endl;
  cout << "\tdivision= " << mf.GetDivision() << endl;
  
  for (track=0; track<mf.GetNumTracks(); track++){
    cout << "track " << track << ":\n";
    for (event=mf.NextEvent(track); event!=NULL; event=mf.NextEvent(track)){
      Tclm_PrintEvent(cout, event);
      cout << endl;
    }
  }
}
